//+------------------------------------------------------------------+
//|                                                          DMA.mq4 |
//|                                      Copyright  2010, LenIFCHIK |
//| DMA (Displaced Moving Averages)      |
//| 3  :                                        |
//| - 3-      ,        |
//|        (  - SR_DSMA);  |
//| - 7-      ,        |
//|        (  - MR_DSMA);|
//| -	25-      ,       |
//|       (  - LR_DSMA). |
//+------------------------------------------------------------------+
#property copyright "LenIFCHIK"

#property indicator_chart_window                          //                                    
#property indicator_buffers 3                             //  
#property  indicator_color1  Red                          //  SR DSMA
#property  indicator_color2  Blue                         //  MR DSMA
#property  indicator_color3  Lime                         //  LR DSMA
//----   
//----  SR DSMA
extern int SR_DSMA_Period=3;                              //  SR DSMA
extern int SR_DSMA_Shift=3;                               //  SR DSMA
//----  MR DSMA
extern int MR_DSMA_Period=7;                              //  MR DSMA
extern int MR_DSMA_Shift=5;                               //  MR DSMA       
//----  LR DSMA
extern int LR_DSMA_Period=25;                             //  LR DSMA
extern int LR_DSMA_Shift=5;                               //  LR DSMA
//----    (1-on,2-off)
extern string Display_mode="0 - on, 1 - off";
extern int SR_DSMA_disp=1;                                //   SR DSMA 
extern int MR_DSMA_disp=1;                                //   MR DSMA 
extern int LR_DSMA_disp=1;                                //   LR DSMA 
//----  
double     SR_DSMA_Buffer[];                              //  SR DSMA
double     MR_DSMA_Buffer[];                              //  MR DSMA
double     LR_DSMA_Buffer[];                              //  LR DSMA
//----
int ExtCountedBars=0;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//----  
//----   SR DSMA   
   switch(SR_DSMA_disp)                                   
     {
      case 0 :   
        SetIndexStyle(0,DRAW_NONE);break;                 //  
      case 1 :   
        SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,1);break;   // 
      default :
        SR_DSMA_disp=1;                                   //   
     }   
//----   MR DSMA 
   switch(MR_DSMA_disp)                                   
     {
      case 0 :   
        SetIndexStyle(1,DRAW_NONE);break;                 //  
      case 1 :   
        SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,1);break;   // 
      default :
        MR_DSMA_disp=1;                                   //   
     }   
//----   LR DSMA 
   switch(LR_DSMA_disp)                                   
     {
      case 0 :   
        SetIndexStyle(2,DRAW_NONE);break;                 //  
      case 1 :   
        SetIndexStyle(2,DRAW_LINE,STYLE_SOLID,1);break;   // 
      default :
        LR_DSMA_disp=1;                                   //   
     }   
//----  
   SetIndexShift(0,SR_DSMA_Shift);                        //   SR DSMA   
   SetIndexShift(1,MR_DSMA_Shift);                        //   MR DSMA   
   SetIndexShift(2,LR_DSMA_Shift);                        //   LR DSMA   
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));     //       
//----  ,      DataWindow    
   SetIndexLabel(0,"SR DSMA");                            
   SetIndexLabel(1,"MR DSMA");                            
   SetIndexLabel(2,"LR DSMA");                            
//----       ,       
   SetIndexDrawBegin(0,SR_DSMA_Period-1);                 
   SetIndexDrawBegin(1,MR_DSMA_Period-1);
   SetIndexDrawBegin(2,LR_DSMA_Period-1);   
//----  ,    ,    
   SetIndexBuffer(0,SR_DSMA_Buffer);
   SetIndexBuffer(1,MR_DSMA_Buffer);
   SetIndexBuffer(2,LR_DSMA_Buffer);   
//----  
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   if(Bars<=LR_DSMA_Period) return(0);
   ExtCountedBars=IndicatorCounted();
//---- 
   if (ExtCountedBars<0) return(-1);
//---- 
   if (ExtCountedBars>0) ExtCountedBars--;
//----      
   double sum=0;
   int    i,pos=Bars-ExtCountedBars-1;
   if(pos<SR_DSMA_Period) pos=SR_DSMA_Period;
   for(i=1;i<SR_DSMA_Period;i++,pos--)
      sum+=Close[pos];
   while(pos>=0)
     {
      sum+=Close[pos];
      SR_DSMA_Buffer[pos]=sum/SR_DSMA_Period;
	   sum-=Close[pos+SR_DSMA_Period-1];
 	   pos--;
     }
   if(ExtCountedBars<1)
      for(i=1;i<SR_DSMA_Period;i++) SR_DSMA_Buffer[Bars-i]=0;
//----      
   double sum1=0;
   int    pos1=Bars-ExtCountedBars-1;
   if(pos1<MR_DSMA_Period) pos1=MR_DSMA_Period;
   for(i=1;i<MR_DSMA_Period;i++,pos1--)
      sum1+=Close[pos1];
   while(pos1>=0)
     {
      sum1+=Close[pos1];
      MR_DSMA_Buffer[pos1]=sum1/MR_DSMA_Period;
	   sum1-=Close[pos1+MR_DSMA_Period-1];
 	   pos1--;
     }
   if(ExtCountedBars<1)
      for(i=1;i<MR_DSMA_Period;i++) MR_DSMA_Buffer[Bars-i]=0; 
//----      
   double sum2=0;
   int    pos2=Bars-ExtCountedBars-1;
   if(pos2<LR_DSMA_Period) pos2=LR_DSMA_Period;
   for(i=1;i<LR_DSMA_Period;i++,pos2--)
      sum2+=Close[pos2];
   while(pos2>=0)
     {
      sum2+=Close[pos2];
      LR_DSMA_Buffer[pos2]=sum2/LR_DSMA_Period;
	   sum2-=Close[pos2+LR_DSMA_Period-1];
 	   pos2--;
     }
   if(ExtCountedBars<1)
      for(i=1;i<LR_DSMA_Period;i++) LR_DSMA_Buffer[Bars-i]=0; 
  }

//+------------------------------------------------------------------+